Index: src/lib/sys/seterrno.c
===================================================================
--- src/lib/sys/seterrno.c	(revision 3946)
+++ src/lib/sys/seterrno.c	(working copy)
@@ -73,7 +73,69 @@
   EINVAL, E2BIG,  ENOENT, EIO,    EIO,     /* 315..319 */
   EINVAL, EINVAL, EINVAL, EINVAL, EAGAIN,  /* 320..324 */
   EINVAL, EINVAL, EINVAL, EIO,    ENOENT,  /* 325..329 */
-  EACCES, EACCES, EACCES, ENOENT, ENOMEM   /* 330..334 */
+  EACCES, EACCES, EACCES, ENOENT, ENOMEM,  /* 330..334 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 335..339 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 340..344 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 345..349 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 350..354 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 355..359 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 360..364 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 365..369 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 370..374 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 375..379 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 380..384 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 385..389 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 390..394 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 395..399 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 400..404 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 405..409 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 410..414 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 415..419 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 420..424 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 425..429 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 430..434 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 435..439 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 440..444 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 445..449 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 450..454 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 455..459 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 460..464 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 465..469 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 470..474 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 475..479 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 480..484 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 485..489 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 490..494 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 495..499 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 500..504 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 505..509 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 510..514 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 515..519 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 520..524 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 525..529 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 530..534 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 535..539 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 540..544 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 545..549 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 550..554 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 555..559 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 560..564 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 565..569 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 570..574 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 575..579 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 580..584 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 585..589 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 590..594 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 595..599 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 600..604 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 605..609 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 610..614 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 615..619 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 620..624 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 625..629 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 630..634 */
+  EINVAL, EINVAL, EINVAL, EINVAL, EINVAL,  /* 635..639 */
+  ETIMEDOUT, EINVAL, EINVAL, EINVAL, EINVAL,  /* 640..644 */
 };